/* $Id: xnd_rdh.h,v 1.2 2004/07/30 08:04:34 berar Exp $ */
/* XND_RDH.H   */

#include <string.h>
#include <ctype.h>
#include <time.h>

/* code identification exper : lecture.nature */
#define LECT_NAT_RX   1
#define LECT_NAT_N    2
#define LECT_NAT_RXA  4
#define LECT_NAT_NM   8



#ifndef EXTERN_RD
#define EXTERN_RD extern
#endif

typedef struct
{
		 int    codepar[MAX_COD];
		 DIFDAT_PTR difdat[MAX_DIF];
		 SYMGRP_PTR symgrp[MAX_SYM];
		 int    max_ordre;
		 int    nl_ano;
       int    nl_sym;
       int    nl_dif;
		 int    prt_sym;
		 int    prt_dif;
		 int    back_code;
		 int    tmp_default;
		 int    nature;
		 int    n_magnet;
		 int    n_modul;
		 int    ini_date;
		 int    valid_reste;
		 int    sites;
		 long   tot_points;
		 long   max_points;
		 struct tm date;
		 char   sym_name[NAME_LG];
		 char   dif_name[NAME_LG];
       char   prg_name[NAME_LG];
       char   coord_name[NAME_LG];
       char   tmp_path[NAME_LG];
		 char   data_path[NAME_LG];
		 int    rem_nb;
		 char   **rem0;
       char   **rem1;
		 char   *argc;
		 ANODAT_PTR *anodat;
		 }      LECT;

EXTERN_RD  LECT   *lect;
EXTERN_RD  FILE   *coord_fich;

/*  --------------------------------------------- */
/* defined in XND_RD.C */

void strup     PROTO((char *string));
void purge_cr  PROTO((void));
void make_path PROTO((char *result, char *path, char *id));

/*  --------------------------------------------- */
/* defined in XND_REXP.C */
void write_chk PROTO((void));
FLOAT read_chk PROTO((void));
int  read_exper PROTO((void));
/* defined in XND_REX1.C */
void get_real_data PROTO ((void));
/* defined in XND_REX2.C */
void get_mult_data PROTO ((void));
/* defined in XND_REX3.C */
void get_hkl_data PROTO ((void));

/*  --------------------------------------------- */
/* defined in XND_RPHA.C */
void read_phase PROTO(( int phase_num ));
/*  --------------------------------------------- */
/* defined in XND_RCRY.C */
void fget_phase_prof PROTO((void));
void fget_phase_orien PROTO((void));
void fget_crystal PROTO((int nb_hkl));
 /*  --------------------------------------------- */
/* -------------------------------------------------- */
/* defined in XND_R11.C */
int get_11hdr PROTO((void));
int new_11hdr PROTO((void));
/* -------------------------------------------------- */
/* defined in XND_R12.C */
int get_12hdr PROTO((void));
int new_12hdr PROTO((void));
/* -------------------------------------------------- */
#undef  EXTERN_RD
