static char *cvs_id =" $Id: xnd_rex2.c,v 1.2 2004/07/30 08:04:36 berar Exp $ ";
/* XND_REX2.C   read the experimental data ( 2dim files) */

#define USE_KEYS
#define USE_SCAN
#define USE_EXPER
#define USE_OBS
#include "../xnd_def.h"
#include "xnd_rdh.h"
#include "../xnd_mem.h"
#define EPS_CHK 0.01
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
/* lecture sur fichier multiple ILL D1B, D20 */
/* ------------------------------------------------------------------ */
static float analyse_date (P_(char *) ligne)
#ifdef NO_PROTO
char *ligne;
#endif
{   struct tm date;
    char  mois[4];
    float valeur;
   if (l_exper->dfich == 20)
   {    sscanf (ligne, "%d%*c%3c%*c%d%d%*c%d%*c%d",
	&date.tm_mday, mois, &date.tm_year, &date.tm_hour, 
	&date.tm_min, &date.tm_sec);
	switch (mois[0]) {
	case 'J' : if (mois[1] == 'A') date.tm_mon = 0;
		else if (mois[2] == 'N') date.tm_mon = 5;
		else date.tm_mon = 6; break;
	case 'F' : date.tm_mon = 1; break;
	case 'M' : if (mois[2] == 'R') date.tm_mon = 2;
		else date.tm_mon = 4; break;
	case 'A' : if (mois[1] == 'P') date.tm_mon = 3;
		else date.tm_mon = 7; break;
	case 'S' : date.tm_mon = 8;  break;
	case 'O' : date.tm_mon = 9;  break;
	case 'N' : date.tm_mon = 10;  break;
	case 'D' : date.tm_mon = 11;  break;
	}
	if (lect->ini_date++ == 0)
	{     lect->date = date;
		return 0;
		}

	date.tm_mday += 365 * (date.tm_year - lect->date.tm_year);
	date.tm_mday += 30 * (date.tm_mon - lect->date.tm_mon);
	valeur = date.tm_sec - lect->date.tm_sec;
	valeur += 60 * (date.tm_min - lect->date.tm_min);
	valeur += 3600 * (date.tm_hour - lect->date.tm_hour);
	valeur += 86400L * (date.tm_mday - lect->date.tm_mday);
	return valeur;
	}
	fprintf (list_fich, " format Date inconnu!");
    return 0;

     }
/* ------------------------------------------------------------------ */
#define  F1B_LUES 20
static void get_f1b_data (P_(FILE *) fich)
#ifdef NO_PROTO
FILE *fich;
#endif
{    int     i, j, idiag, nb;
     TYPE_OBS    *obs;
     F_INFO *l_info;
     int     tot, saut;
     float   xmono, smono;
     float   dt0, teff, pas;
     float   sdiv, val, scale, scalew;
     float   lecvar[F1B_LUES];
     char    ligne [150];
     char    message[40];

     l_info = l_exper->f_info;
     tot = saut = 0;

      j=fscanf (fich,"%d", &i);
      tst_abort ((j!=1),"Erreur lecture data");
      fprintf (list_fich," Le fichier contient %d blocs\n", i);
      for (idiag = 0; idiag < l_exper->n_diag; )
      {   fgets (ligne, 150, fich); 
          fgets (ligne, 150, fich); 
     	  for (j=0; j<F1B_LUES; j++) fscanf(fich,"%f", &lecvar[j]);
     	  if (l_info->numvar >= 1 && l_info->numvar <= F1B_LUES)
     	  	teff = lecvar[l_info->numvar-1];
     	  else	 teff = analyse_date(ligne);    	  
     	  fgets (ligne, 150, fich);  /* indic calib en fin de ligne */
	  if (idiag != 0) sprintf (l_diag->fich_name," Diag #%d", idiag+1);
	  
	  l_diag->dtheta0 = dt0  = lecvar[4];
          l_diag->w_mini = MINFLOAT;
	  xmono = lecvar[2];
	  pas  = lecvar[10];
	  nb   = lecvar[14];
	  if (teff < l_info->tmin) 
	  	for (i = 0; i < nb / 10; i++) fgets(ligne, 150, fich);
	  else 
	  if (l_info->skip && tot >= l_info->cumul) 
	  {	if (saut++ < l_info->skip) 
	  		for (i = 0; i < nb / 10; i++) fgets(ligne, 150, fich);
	        if (saut >= l_info->skip) tot = 0;
		}
	  else 
	  {     if ( l_info->skip==0 && tot >= l_info->cumul) tot =0;
	        if (tot== 0) 
	        {    l_diag->temp = teff;
	             obs = (TYPE_OBS *) tst_alloc (nb, sizeof(TYPE_OBS),"OBS");
	             }
  	        else l_diag->temp += teff;
		tot++;
	  	saut =0;
	  	if (l_info->mono != 0) scale = l_info->mono / xmono;
	  	else scale = 1;
                scale /= l_info->cumul;
                scalew = scale * (l_info->cumul * l_info->cumul);
		smono = 1 / (xmono * l_info->cumul);
	  	for (i = 0; i < nb; i++)
	        {   j=fscanf(fich,"%f%f",&sdiv, &val);
                    sprintf (message,"i_obs bloc %f",lecvar[0]); 
	            tst_abort((j==0),E_READ,message,dt0);
		    if (tot == 1)
		    {   obs[i].dtheta = dt0;
		        obs[i].i_obs = 0;
		        }
		    obs[i].i_obs += val;
		    if (tot == l_info->cumul)
		    {   val = obs[i].i_obs;
                        obs[i].i_obs *= scale;
		        obs[i].weight = smono;
		        obs[i].weight += (val > 0) ? ( 1/val ) : 1;
		        obs[i].weight *= scalew;
                        obs[i].weight *= l_exper->weight;
        if (obs[i].i_obs > l_diag->y_max ) l_diag->y_max = obs[i].i_obs;
			data_write (&obs[i]);
			if (obs[i].weight>0 && obs[i].weight>l_diag->w_mini)
			      l_diag->w_mini = obs[i].weight;
			 }
		    dt0 += pas;
		    } /* for i < nb */
	      if (tot == l_info->cumul)
	      {	  l_diag->w_mini = 1 / sqrt (l_diag->w_mini);
	  	  l_diag->dthetaf = obs[nb-1].dtheta;
	          l_diag->n_points = nb;
		  l_diag->temp /= l_info->cumul;
		  write_chk();
		  free (obs);
		  fprintf (list_fich," diag #%d, T = %f, %d points lus entre %.3f et %.3f\n",
		  idiag, l_diag->temp, l_diag->n_points,l_diag->dtheta0,l_diag->dthetaf);
	          if ( nb && nb != l_diag->n_points && idiag==0)
	             fprintf (list_fich,"Nb de points declares non conforme\n");
                  lect->tot_points += l_diag->n_points;
                  if (l_diag->n_points > lect->max_points)
			lect->max_points = l_diag->n_points;
		  idiag ++; l_diag++;
		 }
	     } /* else  teff ou skip */
     
      j=fscanf (fich,"%d", &i);  /* le -1000 final */
      }  /* for idiag */
	  }

/* ------------------------------------------------------------------ */
/* lecture sur fichier multiple VDMI  cas 21 */
static void get_vdmi_data (P_(FILE *) fich)
#ifdef NO_PROTO
FILE *fich;
#endif
{    int     i, j, idiag, neff;
     TYPE_OBS     *obs;
     F_INFO *l_info;
     int     tot, saut;
     float   smono;
	  float   teff;
     float   val, scale, scalew;
     float  *lecvar;
     int     ncx, ncy, nl_par;
     float   *eff, *s_eff;
     float   dummy;

/* on lit d'abord ndiags, npts et npar puis npts abscisses */

     l_info = l_exper->f_info;
     tot = saut = 0;
     fscanf(fich,"%d%d%d%d", &ncy, &ncx, &nl_par, &neff);
     obs = (TYPE_OBS *) tst_alloc (ncx, sizeof(TYPE_OBS),"OBS");
     eff = (float *) tst_alloc (ncx, sizeof(float),"eff");
     s_eff = (float *) tst_alloc (ncx, sizeof(float),"eff");
     for (i=0; i<ncx; i++) fscanf (fich,"%f", &obs[i].dtheta);
     if (neff ) for (i=0; i<ncx; i++)
     {   fscanf (fich,"%f",&eff[i]);
         tst_abort (( eff[i] < EPSILON )," Efficacite negative ou nulle");
         s_eff[i] = sqrt (eff[i]); 
         if (neff > 0) eff[i] = 1.0 /eff[i]; else eff[i] = 1.0;
         }
     else 
     for (i=0; i<ncx; i++) s_eff[i] = eff[i] = 1.0;
      
     tst_abort ((l_exper->n_diag > ncy * (l_info->cumul+l_info->skip)),"Plus de exper que d'enregistrements");
     tst_abort ((l_info->numvar> nl_par),"Variable T non enregistree");
     lecvar = (float *) tst_alloc (1+nl_par, sizeof(float),"vdmi");
     
     if (l_info->mono > 1) smono = 1 / l_info->mono;
           else smono = 0;
     scale = 1.0 / l_info->cumul;
     scalew = l_info->cumul * l_info->cumul;
     smono *= l_info->cumul;

     for (idiag = 0; idiag < l_exper->n_diag; )
     {    for (j=0; j<=nl_par; j++)  
             tst_abort((fscanf(fich,"%f", &lecvar[j])!=1),"EOF fichier data");
     	  teff = lecvar[l_info->numvar];
	  if (idiag != 0) sprintf (l_diag->fich_name," Diag #%d", idiag+1);

	  if (teff < l_info->tmin) 
	  	for (i = 0; i < ncx; i++) fscanf(fich,"%f", &dummy);
	  else
	  if (l_info->skip && tot >= l_info->cumul) 
	  {	if (saut++ < l_info->skip) 
	  	     for (i = 0; i < ncx; i++) fscanf(fich,"%f", &dummy);
	        if (saut >= l_info->skip) tot = 0;
		}
	  else 
	  {     if ( l_info->skip==0 && tot >= l_info->cumul) tot =0;
	        if (tot== 0) 
                {    l_diag->temp = teff;
                     tst_abort ((lecvar[0]+l_info->cumul > ncy ), 
                          "Le cumul depasse le nombre de diag du fichier\n");
                     }
	        else l_diag->temp += teff;
		tot++;
	  	saut =0;
	  	for (i = 0; i < ncx; i++)
	        {   j=fscanf(fich, "%f", &val);
	            tst_abort((j==0), E_READ, "i_obs", obs[0].dtheta);
		    if (tot == 1) obs[i].i_obs = 0;
		    obs[i].i_obs += val;
		    if (tot == l_info->cumul)
		    {   val = obs[i].i_obs;
			obs[i].i_obs *= scale * eff[i];
		        obs[i].weight = smono;
		        obs[i].weight += (val > 0) ? ( 1/val ) : 1;
		        obs[i].weight *= scalew *s_eff[i];
                        obs[i].weight *= l_exper->weight;
        if (obs[i].i_obs > l_diag->y_max ) l_diag->y_max = obs[i].i_obs;
			data_write (&obs[i]);
			if (obs[i].weight>0 && obs[i].weight>l_diag->w_mini)
			      l_diag->w_mini = obs[i].weight;
			 }
		    } /* for i < ncx */
	      if (tot == l_info->cumul)
	      {	  l_diag->w_mini = 1 / sqrt (l_diag->w_mini);
	  	  l_diag->dthetaf = obs[ncx-1].dtheta;
	  	  l_diag->dtheta0 = obs[0].dtheta;
	          l_diag->n_points = ncx;
	          l_diag->temp /= l_info->cumul;
		  write_chk();
		  fprintf (list_fich," diag #%d, T = %f, %d points lus entre %.3f et %.3f\n",
		  idiag, l_diag->temp, l_diag->n_points, l_diag->dtheta0, l_diag->dthetaf);
	          if ( ncx && ncx != l_diag->n_points && idiag==0)
	             fprintf (list_fich,"Nb de points declares non conforme\n");
                  lect->tot_points += l_diag->n_points;
                  if (l_diag->n_points > lect->max_points)
			lect->max_points = l_diag->n_points;
		  idiag ++; l_diag++;
		 }
	     } /* else  teff ou skip */	
	   }  /* for idiag */
         free (obs);
        free (lecvar);
	  }

/* ------------------------------------------------------------------ */
/* lecture sur fichier multiple, preparation  */
void get_mult_data (P_(void))
{  FILE   *fich;
   TYPE_OBS    obs;
   F_INFO *l_info;
   int    idiag, i, nb;

   l_exper->f_info = l_info = (F_INFO *)tst_alloc (1,sizeof(F_INFO),"f_info");
   l_diag->fich_name[0] = 0;l_info->mono=0;
	if ( get_keys("DATA", NULL,
      "FILE",    KEYTYPE_CHAR, &(l_diag->fich_name), &l_diag->fich_name, 
      "SIZE",    KEYTYPE_INT,    &(nb),             0,
      "TEMP",    KEYTYPE_FLOAT,  &(l_diag->temp),    &l_exper->temp_orig,
      "SUM",     KEYTYPE_INT,  &(l_info->cumul),     1,
      "SKIP",    KEYTYPE_INT,  &(l_info->skip),      0,
      "VAR",     KEYTYPE_INT,  &(l_info->numvar),    1,
      "MONIT",   KEYTYPE_FLOAT,  &(l_info->mono),    &l_info->mono,
        NULL ) == -1 )
   /* the following allows xnd_1.17 header to be read */
    fscanf (coord_fich,"%d%f%d%d%d%f %[^\n]",
     	    &nb, &l_info->tmin, 
     	    &l_info->cumul, &l_info->skip, &l_info->numvar, 
     	    &l_info->mono, l_diag->fich_name);
     if (l_info->cumul == 0) l_info->cumul = 1;
     fprintf (list_fich,
     " DIAG : (%d points) a partir  de T = %.3f (cumul %d saut %d) \n\
       variable %d, moniteur %f, fichier : '%s'\n",
	nb, l_info->tmin, l_info->cumul, l_info->skip, 
	l_info->numvar, l_info->mono, l_diag->fich_name);

     if ((disk_data&2) == 0)
     {    
	fich = tst_open (l_diag->fich_name,"rt","data file");
	switch (l_exper->dfich)
	{  case 20 : get_f1b_data  (fich);   break;
	   case 21 : get_vdmi_data (fich);   break;
/*	   case 22 : get_edf_data (fich);   break;
	   case 23 : get_gel_data (fich);   break;
*/	   }
	 fclose (fich);
	 }
     else   /* disk_data : lecture sur fichier binaire interne */
     {  for (idiag = 0; idiag < l_exper->n_diag; idiag++, l_diag++)
     {    l_diag->n_points = nb;
	  for (i=0;i<nb;i++) data_read (&obs);
	  l_diag->temp = read_chk();
	  lect->tot_points += l_diag->n_points;
	  if (l_diag->n_points > lect->max_points)
		lect->max_points = l_diag->n_points;
	   }  
	}      
     }
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */

