/* $Id: xnd_vah.h,v 1.1 2004/07/30 08:05:17 berar Exp $ */
/*  XND_VAR.H   declaration des variables globales */

 EXTERN char  titre[NAME_LG];
 EXTERN char  *str_time;
 EXTERN char  *host;
				     /*  file system */
 EXTERN FILE  *list_fich;
 EXTERN FILE  *new_fich;
 EXTERN FILE  *hkl_fich;
 EXTERN FILE  *plg_fich;
 EXTERN FILE  *cif_fich;
 EXTERN FILE  *data_fich;
 EXTERN FILE  *bragg_fich;
 EXTERN FILE  *remark_fich;
 EXTERN FILE  *hkldata_fich;
 EXTERN sint  end0_remark;
 EXTERN sint  end1_remark;
 EXTERN char  dydp_name[NAME_LG];
 EXTERN char  data_name[NAME_LG];
 EXTERN char  remark_name[NAME_LG];
 EXTERN char  new_name[NAME_LG];
 EXTERN char  plg_name[NAME_LG];
 EXTERN char  hkl_name[NAME_LG];
 EXTERN char  cif_name[NAME_LG];
 EXTERN char  list_name[NAME_LG];


 EXTERN int   cycle;                 /* general parameters */
 EXTERN int   max_cycle;
 EXTERN int   c_marquardt;
 EXTERN int   mod_lsq;
 EXTERN int   back_mode;
 EXTERN int   tot_prof_par;
 EXTERN int   phase_prof_par;
 EXTERN int   voigt_mode;
 EXTERN int   asym_mode;
 EXTERN int   unc_mode;
 EXTERN int   valid_ref;
 EXTERN int   test_mode;
 EXTERN float eps_stop;
 EXTERN float eps_prof;
 EXTERN float relax;
 EXTERN float marquardt;
 EXTERN float val_sigma;
 EXTERN float xt_eff;
 EXTERN float opt_deplace;
 EXTERN float u_exp;
 EXTERN float u_sin;
			/* constantes modifiables en mode test */
#ifdef EXTERN_NOT_SPACE
 extern float bragg_repart;
 extern float asym_rmin;
 extern float asym_rmax;
 extern int asym_resol;
 extern int asym_width;
#else
	float bragg_repart = 0.5;
   float asym_rmin = 0.125;  /* limit of convolution : w_asym < asym_rmin * dphi_mini */
   float asym_rmax = 0.125;  /* limit of convolution : dphi_mini < asym_rmax * w_asym */
   int asym_resol = 30;      /* points inside line width */
   int asym_width = 8;       /* widths to convoluate */
#endif
 
                          /* io parameters */
 EXTERN int   prt_new;
 EXTERN int   prt_hkl;
 EXTERN int   prt_plg;
 EXTERN int   prt_cor;
 EXTERN int   prt_cif;
 EXTERN int   disk_dydp;
 EXTERN int   disk_data;
 EXTERN char  bavard;
 EXTERN char  fini;
 EXTERN int   minli;
 
			  /* effective size */
 EXTERN int   n_exper;
 EXTERN int   n_phase;           /* as read */
 EXTERN int   tot_phase;         /* with modulated pseudo-phases */
 EXTERN int   n_var;
 EXTERN int   n_par;
 EXTERN int   n_pen;
 EXTERN int   n_mat;
 EXTERN int   n_sym;
 EXTERN int   n_dif;
 EXTERN int   nt_diag;
				 /* basic pointers */
 EXTERN FLOAT  *matrice;
 EXTERN FLOAT  *y_vect;
 EXTERN float  *shift_e;
 EXTERN float  *prof_mat;
 EXTERN int    *prof_pos;
 				    /* current pointers */
 extern PHASE_PTR l_phase;
 EXTERN VAR_PTR  l_onde;
 EXTERN VAR_PTR  l_instru;
 EXTERN VAR_PTR  l_asym;
 EXTERN VAR_PTR  l_reglage;
 EXTERN FLOAT  *l_points;
 EXTERN VAR_PTR  l_bloc;
				   /* current parameters */
 EXTERN float  *temp;
 EXTERN float  temp_phase;
 EXTERN float  q, tan_t;
 EXTERN char   centro,systeme,bravais;
 EXTERN float  q_eff[3];                       /* hkl used for modulation.. */
 EXTERN float  g_aa,g_ab,g_ac,g_bb,g_bc,g_cc;  /* reciprocal metric */
 EXTERN float  d_aa,d_bb,d_cc,d_ab,d_ac,d_bc;  /* direct */
 EXTERN float  na_b,nb_b,nc_b;                 /* unit vect b for orien */
 EXTERN float  d_metric[6];
 EXTERN unsigned n_pts;
 EXTERN unsigned dif_nature;
 EXTERN int     fhkl_mult;      /* multiply factor for hkl according to sym */
 EXTERN int     magnet;
 EXTERN int     incom;
 EXTERN int     sat;
 EXTERN int     max_asym;
 EXTERN int     dim_centro;     /*  1 if phase is centro, 2 elsewhere */

 extern  int   auto_intensity;
 			
#define    h_eff    q_eff[0]
#define    k_eff    q_eff[1]
#define    l_eff    q_eff[2]

