static char *cvs_id =" $Id: xnd_der.c,v 1.5 2004/07/30 08:04:03 berar Exp $ ";
/* XND_DER.C  calculation of derivative at each point of the profil ... */

#define  USE_RBRG
#define  USE_BRAGG
#define  USE_VAR
#define  USE_SETS
#define  USE_MODUL
#define  USE_EXPER
#define  USE_ATOM
#define  USE_PENAL
#define  USE_PHASE
#include "../xnd_def.h"
#include "../xnd_cah.h"
#include "../xnd_mem.h"
/* ----------------------------------------------------------- */
   static int test = 0;
/* ----------------------------------------------------------- */
int profil_point (P_(int) pos)
#ifdef NO_PROTO
int pos;
#endif
/* this procedure is called at each point, that is why most calculations */
/* are done directly without call to specialised procedure               */
{  int   ii,i,j,ip,ib,ia;
   int   dxpos;
   float z,val,val_f;

   dt = *l_points-DTH;
   val = profil ();
   if (val > 0 )
   {  add_ical(pos, val);
      if (do_derivatives)
/* calcul des derivees en ce point, pos,2wg2,wl,as.. */
      {  d_pil ();
	      val_f = fhkl_2 > EPSILON ? 2 * val / fhkl_2 : 0;
	      temp = &temp_exper;
/* onde */
	if (var_ideriv(l_onde))
	{  VAR_io_id  for (i=act->lambda*LAMBDA;i<act->lambda*LAMBDA+LAMBDA;i++)
	if ((j=var_param(i))!=0)
	{  switch (i%LAMBDA)
	 { case 0 : z = d_p_t * tan_t  / (RAD * lambda);   break;
		case 1 : z = val / exper_echelle;               break;
		case 2 : z = d_p_l * fabs(tan_t-tan_tm) * sign_onde;        break;
	   case 3 : z = d_p_g * sqr(tan_t-tan_tm) * var_valeur(i);
	   }
	   add_dydp(pos, j, z * var_derive());
	 }  }
/* zero, polar, eclair .... */
   if (var_ideriv(l_reglage))
	{  VAR_io_id  for (i=0;i<var_number;i++)
	if ((j=var_param(i))!=0)
	{  switch (i)
	 { case 0 : z = d_p_t;                         break;
	   case 1 : z = val *(cos2_2t-1)/((1+cos2_2t*polar)*(1+polar)); break;
	   case 2 :
	       	var_init(l_onde);
		z = - d_p_l * var_valeur(act->lambda*LAMBDA+2);
		if (tan_tm > tan_t) z = -z;
	 	z -=  d_p_g * (tan_t-tan_tm) *
	 		sqr(var_valeur(act->lambda*LAMBDA+3));
	    	var_init(l_reglage); break;
	   case 3 : z =  sin_t<eclair ? - val /eclair : 0; break;
	   case 4 : if (l_exper->techn == 1) z = 0; break;
	   case 5 : z = val * abs_cyl; break;
	   case 6 : z = val * abs_pl; break;
	   }
	   add_dydp(pos, j, z * var_derive());
	  }  }
/* instru */
   if (var_ideriv(l_instru))
	{  VAR_io_id  for (i=0;i<l_exper->instru->number;i++)
	if ((j=var_param(i))!=0)
	{  switch (i)
	{  case 0 : z = d_p_l * sign_instru0;    break;
	   case 1 : z = d_p_g * var_valeur(1);    break;
		case 2 : z = d_p_l * fabs(cotan_2t) * sign_instru2;    break;
	   case 3 : z = d_p_g * sqr(cotan_2t) * var_valeur(3);    break;
	   case 4 : z = d_p_l * dpro_asym;    break;
	   case 5 : z = d_p_g * sqr(dpro_asym) * var_valeur(5);    break;
	   case 6 : z = d_p_l * sqr(dpro_asym);    break;
	   case 7 : z = d_p_g * sqr(sqr(dpro_asym)) * var_valeur(7);    break;
	    }
	   add_dydp(pos, j, z * var_derive());
	  }  }
/* asym : convolution parameters */
   if (var_ideriv(l_exper->ascnv))
	{  VAR_io_id  for (i=0;i<2;i++)
	   if ((j=var_param(i))!=0)
	   add_dydp(pos, j, d_pa_ins[i]  * var_derive());
	   }

/* asym : calculation depend on asym_mode */
   if (var_ideriv(l_asym))
	{  VAR_io_id  for (ip=0;ip<max_asym;ip++) for (i=0;i<ASYM;i++)
	   if ((j=var_param(i+ip*ASYM))!=0)
	   {  switch (i)
	      {  case 0 : z = d_p_a[ip] * cotan_2t;       break;
	         case 1 : z = d_p_a[ip] / tan_t;        break;
	         case 2 : z = d_p_a[ip] * sin_2t;       break;
	         }
	      add_dydp(pos, j, z * var_derive());
	   }  }
/* ------------------------------------------------------ */
	temp = &temp_phase;
/* phase scale , overall B */
   if (var_ideriv(l_phase->ech))
	{  VAR_io_id  for (i=0;i<l_phase->ech->number;i++)
	if ((j=var_param(i))!=0)
	   add_dydp(pos, j, val * var_derive()* *(d_echelle+i));
		 }
/* phase transition scale */
   if (var_ideriv(l_phase->transit))
	{  VAR_io_id  for (i=0;i<var_number;i++)
	if ((j=var_param(i))!=0)
	   add_dydp(pos, j, val * var_derive()* *(d_echelle+l_phase->ech->number+i));
		 }
/* cell parameters */
	if (l_phase->nature != PHASE_PARASITE)
	{  if (var_ideriv(l_phase->cell))
	   VAR_io_id  for (i=0;i<var_number;i++)
	   if ((j=var_param(i))!=0)
	   {    if (i!=0) 
           {    z = d_metric[i-1];
                } 
           else if ((l_exper->techn % 4) != 3) /* centering */
           {    z = cos_t; 
                } 
           else          /* centering on curved PSD */
           {    z = sin_2t; 
                }
	   add_dydp(pos, j, z * d_p_t * var_derive());
	    }  } 
/* phase orien */
	if (var_ideriv(l_phase->orien))
	{	VAR_io_id  for (ip=0;ip<l_phase->n_orien;ip++) for (i=0;i<ORIEN;i++)
	  if ((j=var_param((org_orien+ip)*ORIEN+i))!=0)
	   add_dydp(pos, j, val * orien_val[ORIEN*ip+i] * var_derive()/ act->orien);
	   }
/* phase line width and asym */
   if (l_phase->n_prof) 
	{	if (var_ideriv(l_phase->prof))
	{  VAR_io_id  for (ip=0;ip<l_phase->n_prof;ip++) for (i=0;i<PROF;i++)
	if ((j=var_param(ip*PROF+i))!=0) if (i<PROF_ANG)
	{ switch (i%PROF)
	   {     case 0 : z = sign_phase * d_p_l / cos_t;    break;
	         case 1 : z = d_p_g  * phase_wg/ cos_t;      break;
		      case 2 : z = sign_phase * d_p_l * tan_t;    break;
	         case 3 : z = d_p_g * phase_wg * tan_t;      break;
	         }
	   add_dydp(pos, j, z * orien_prof[ip*ORIEN_PROF] * var_derive());
	    }  
	 else /* if (i<PROF_ANG)  */
	 { z = d_p_l * orien_prof[ip*ORIEN_PROF+3]
	     + d_p_g * orien_prof[ip*ORIEN_PROF+4];
	   for (ia=0;ia<max_asym;ia++) z += d_p_a[ia] *  orien_prof[ip*ORIEN_PROF+5+ia];
	   add_dydp(pos, j, z  * orien_prof[ip*ORIEN_PROF+i-PROF_ANG] * var_derive());
        }  } 
   if (var_ideriv(l_phase->asym))
	{  VAR_io_id  for (ip=ib=0;ip<l_phase->n_prof;ip++) 
	   for (ia=0;ia<max_asym;ia++,ib++)   for (i=0;i<PASYM;i++)
	if ((j=var_param(ib*PASYM+i))!=0) 
	{  switch (i%PASYM)
	  {      case 0 : z =  d_p_a[ia];                   break;
		 case 1 : z =  d_p_a[ia] * tan_t;           break;
	         }
	   add_dydp(pos, j, z * orien_prof[ip*ORIEN_PROF] * var_derive());
	   }  }
      }
/* modulation vectors */
	  if (l_phase->vector && l_phase->vector->number >= 1)
     {  if (var_ideriv (l_phase->vector))
     {  VAR_io_id   for (i=0; i<3*current_modul->size; i++)
	   if ((j=var_param(i))!=0)
	   {   z = vector_deriv[i];
	   add_dydp(pos, j, z * d_p_t * var_derive());
	    } } }
         
/* atomic parameters */
	if (deriv_atom)
	{  dxpos = 0;
	   for (ii=0,l_atom=l_phase->atom; ii<l_phase->n_atom;ii++,l_atom++)
	   {  if (var_ideriv(l_atom->x))
		   {  VAR_io_id  for (i=0;i<l_atom->nb;i++)
		      if ((j=var_param(i))!=0)
		      {  z = F_A * fab_deriv[0][dxpos+i];
		         if (!centro) z += F_B * fab_deriv[1][dxpos+i];
	   add_dydp(pos, j, z * val_f * var_derive());
		      }  }
		    dxpos+=l_atom->nb;
		    if (l_atom->n_modul) 
		    {  if (var_ideriv(l_atom->modul))
		       {  VAR_io_id  for (i=0;i<l_atom->n_modul*AMODUL;i++)
		          if ((j=var_param(i))!=0)
		          {  z = F_A * fab_deriv[0][dxpos+i];
		             if (!centro) z += F_B * fab_deriv[1][dxpos+i];
	   add_dydp(pos, j, z * val_f * var_derive());
                }  }
		      dxpos+=l_atom->n_modul*AMODUL;
		      }       
		  if (l_atom->n_anharm) 
		  {   if (var_ideriv(l_atom->anharm))
		      {  VAR_io_id  for (i=0;i<l_atom->n_anharm;i++)
		      if ((j=var_param(i))!=0)
		      {    z = F_A * fab_deriv[0][dxpos+i];
		           if (!centro) z += F_B * fab_deriv[1][dxpos+i];
	   add_dydp(pos, j, z * val_f * var_derive());
                 }  }
		      dxpos+=l_atom->n_anharm;
		      }       
		  }
/* blocs rigides exprimes ici dans les coordonnees atomiques relatives */
	      for (ib=0; ib<l_phase->nb_bloc;ib++)
	      for (ii=0,l_atom=l_phase->bl_relat[ib]; ii<l_phase->bl_atom[ib];
		     ii++,dxpos+=l_atom->nb,l_atom++)
	     {  if ( var_ideriv(l_atom->x))
		  { VAR_io_id  for (i=0;i<l_atom->nb;i++)
		 if ((j=var_param(i))!=0)
		  {    z = F_A * fab_deriv[0][dxpos+i];
			if (!centro) z += F_B * fab_deriv[1][dxpos+i];
	   add_dydp(pos, j, z * val_f  * var_derive());
		  }   }  }
	      }  /* deriv_atom */
	 else 
	 if (l_phase->n_atom==0 && i_intens)
/* cas des intensites definies , parasites puis phases normales ou quasi*/
	 {   if (var_ideriv(current_sets->intensity))
	     {  VAR_io_id
	     if (l_phase->nature == PHASE_PARASITE)
	     {   ii=2*(i_intens-1);
	         if ((j=var_param(ii))!=0)
	   add_dydp(pos, j,  -2/RAD * tan_t * s * d_p_t * var_derive());
		 if ((j=var_param(ii+1))!=0)
	   add_dydp(pos, j, val*var_derive()/var_valeur(ii+1));
	     } else
	     {   ii=i_intens-1;
	         if ((j=var_param(ii))!=0)
	   add_dydp(pos, j, val*var_derive()/var_valeur(ii));
	     }  } }
      } /* do_derivatives */
      else if ( do_plg_data )
      {  add_ipha(pos, act->phase, val);
         }
   } else val = 0; 
    return (val > minimum);
    }

/* ----------------------------------------------------------- */
/* ----------------------------------------------------------- */
