static char *cvs_id =" $Id: xnd_unc.c,v 1.5 2004/07/30 08:04:09 berar Exp $ ";
/* XND_UNC    generate uncoherent scatering ... */

#define  USE_BRAGG
#define  USE_VAR
#define  USE_SYM
#define  USE_SCAN
#define  USE_EXPER
#define  USE_ATOM
#define  USE_PHASE
#include "../xnd_def.h"
#include "../xnd_cah.h"
#include "../xnd_mem.h"

static float corlp;
/* ---------------------------------------------------------- */
static void add_print_unc( P_(int) p, P_(float) ic, P_(char *) txt)
#ifdef NO_PROTO
int p;
float uncoherent;
char *txt;
#endif
{   add_ical(p, ic);
    if ( fini && act->lambda==0 && ( unc_mode&2 ) != 0 && ( p%(n_pts/10)) ==0)
     fprintf(list_fich, " %9.3f (lambda 0) %s=%9.3g added to ical\n",
                 *l_points, txt, ic);
    if (do_plg_data) add_ipha(p, tot_phase, ic) ;
    }     
/* ---------------------------------------------------------- */
/* part of the tds related to the origin, node 000            */
/* ---------------------------------------------------------- */
void gen_tds_0 (P_(void))
{
   int i, j, p, nsym;
   float f, b, debye, ech_lp, uncoherent;
   push_err_msg("profil_tds_0(xnd_unc.c)");
   if ((dif_nature & EXPER_N)  != 0)            valdif = b_valdif;
      else if ((dif_nature & EXPER_RX) != 0 )   valdif = x_valdif;
      else chk_abort ("dif_nature invalide");
   temp = &temp_phase;
    var_init (l_phase->ech);
    phase_echelle = var_valeur (0);
    ini_metric();    /* ini_metrique */
         nsym = current_symgrp->nops;
        if (current_symgrp->centro) nsym *=2;
   var_init (l_phase->tds);
        ech_lp= var_valeur(2);
   for (act->lambda=0;act->lambda<l_exper->n_lambda;act->lambda++)
   {  temp = &temp_exper;
      var_init (l_onde);
      lambda = var_valeur (act->lambda * LAMBDA);
      exper_echelle = var_valeur(act->lambda*LAMBDA + 1);
      temp = &temp_phase;
      echelle = phase_echelle * exper_echelle;
      temp = &temp_phase;
      for (p=0,l_points=l_diag->points;p<n_pts;p++,l_points++)
      {  uncoherent = 0;
/*verbose_printf("p=%d  l_points %x  %f\n", p, l_points, *l_points);*/
         sin_t = sin(RAD/2 * *l_points );
         cos_t = sqrt(1-sin_t*sin_t);
         s=sin_t/lambda;
         corlp = ech_lp / (sin_t*cos_t) / sin_t; 
/*verbose_printf(" act %X \n", act);*/
         /* if (i_eclair && sin_t<eclair) act->cor *= sin_t/eclair;*/
/*verbose_printf("p=%d ech_lp %f for\n", p, ech_lp );*/
         for (i=0,l_atom=l_phase->atom;i<l_phase->n_atom;i++,l_atom++)  /*   --*--/--  */
         {  var_init (l_atom->x);
            if ((l_atom->nature & 1) == 0) b= var_valeur(4);
                    else b = u_equiv(l_atom->x, NULL);  /* b_equiv */
                 debye = 1.0 - exp (-2 * var_valeur (4) * s * s);
            f = fhkl_mult * (*valdif)();
            uncoherent += f * f * var_valeur(3) * debye ;
            }
         for (j=0;j<l_phase->nb_bloc;j++)
         for (i=0,l_atom=l_phase->bl_relat[j];i<l_phase->bl_atom[j];i++,l_atom++)
         {  var_init (l_atom->x);
            if ((l_atom->nature & 1) == 0) b= var_valeur(4);
                    else b = u_equiv(l_atom->x, NULL);   /* b_equiv */
                 debye =  1.0 - exp (-2 * b * s * s);
            f = fhkl_mult * (*valdif)();
            uncoherent += f * f * var_valeur(3) * debye;
                     }
/*verbose_printf("uncoherent %f for\n", uncoherent );*/
             add_print_unc(p, uncoherent, "tds_000");
              } /* points */
         } /* lambda */
    pop_err_msg();     
    }
/* ---------------------------------------------------------- */
/* ---------------------------------------------------------- */
static ixtds = 0;
static  jxtds = 0;
static char tds_msg[10];
int profil_tds_hkl(int pos, float l_coef, float s_coef, float w_eff)
{  float tds, sc, cc, lambda;
   float a, b, c;
   push_err_msg("profil_tds_hkl(xnd_unc.c)");
        /* sin_t : sin tetha bragg
           sc    : sin tetha */
   sc = sin( 0.5*RAD * *l_points);
   cc =sqrt(1-sc*sc);              
   temp = &temp_exper;
   var_init (l_onde);
   lambda =var_valeur (act->lambda*LAMBDA);
   tds = l_coef * (- sc * log(sqr(w_eff*cos_t)+sqr(sc-sin_t)) + s_coef * sc * sc ); 
/*   if ( (ixtds < 15)  && ( jxtds % 20)== 0) verbose_printf(" tds %f s %f l_coef %f s_coef %f \n", tds, sc, l_coef, s_coef); 
/*   a =(w_eff * w_eff * cc /2 - sc * ( sin_t - sc)/cc - (sqr(sin_t - sc))/2)
         * log( fabs((sin_t-sc-w_eff * cc)/(sin_t-sc+w_eff * cc)))     ;
   b = 2 * w_eff * sc * ( 1 + log( lambda * s_coef ));
   c = w_eff * sc * log(4*fabs(sqr(sin_t - sc) -   sqr(w_eff * cc) )) ;
   tds = l_coef * ( a-b-c) ;
        
   if ( (ixtds < 15)  && ( jxtds++ % 20)== 0) verbose_printf(" tds %f s %f s_coef %f a=%f   b=%f  c=%f   %f\n", tds, sc, s_coef,
            a,  b, c, minimum);*/ 
   if (tds > 0 )
   {  /* if ( (ixtds < 15)  && ( jxtds++ % 20)== 0) verbose_printf(" tds %f s %f l_coef %f s_coef %f \n", tds, sc, l_coef, s_coef); 
*/      add_print_unc(pos, tds, tds_msg );
      if (fini==0 && minli==0)
      {  /* calcul des derivees en ce point, pos,2wg2,wl,as.. */
                   }
          }
   pop_err_msg();
   return (tds > minimum);
   }
/* ---------------------------------------------------------- */
void gen_tds_hkl (P_(void))
{  int   pos;
   float w_eff, l_coef, s_coef;
   w_eff = ((W_L + W_G) * RAD)/2;
   var_init (l_phase->tds);
   l_coef = I_C * var_valeur(1)  / (2 * sin_t ); 
   s_coef = var_valeur(2); 
   sprintf(tds_msg,"tds(%d,%d,%d)", H,K,L);
/*	if (ixtds++ <15)  verbose_printf(" gen_tds_hkl HKL %d %d %d  w_eff %f  Ib %f\n", 
     H, K, L, w_eff, I_C); 
*/ 
   jxtds = 0;
   pos = first_point;
   if (pos <n_pts)
   {  l_points = &l_diag->points[pos];
           while ((pos<n_pts) && (profil_tds_hkl (pos, l_coef, s_coef, w_eff)))
           {  l_points++;
                   pos++;
            }
           pos = first_point - 1;
      l_points = &l_diag->points[pos];
           while (( pos >= 0 )&& (profil_tds_hkl (pos, l_coef, s_coef, w_eff)))
           {  l_points--;
                   pos--;
            }
    }
}
/* ---------------------------------------------------------------- */
/* simplified compton scattering                                    */
/* ---------------------------------------------------------------- */
/* Icompton = 16 * pi^2 /180 * Scale *cell volume * Kpol * Unc /(lambda^3) */
/* -----------------------------------------------------------------*/
void gen_uncoherent (P_(void))
{
    int i, j, p, nsym;
    float uncoherent, ech_lp;
    float d_lambda, width, resol, dl_min, dl_max, dl_eff;
    push_err_msg("gen_uncoherent(xnd_unc.c)");
    if ((dif_nature & EXPER_N)  != 0)            valdif = ub_valdif;
       else if ((dif_nature & EXPER_RX) != 0 )   valdif = ux_valdif;
    else chk_abort ("dif_nature invalide");
    if (l_exper->nature & EXPER_ENER_RESOL )
	 {	  temp = &temp_exper;
        var_init (l_exper->c_exp);
	     resol =  0.5*fabs(var_valeur(0));
		  } else resol = 0;
    temp = &temp_phase;
    var_init (l_phase->ech);
    phase_echelle = var_valeur (0);
    var_init (l_phase->tds);
    if (l_phase->nature != PHASE_RADIAL && l_phase->nature != PHASE_RDFPEAK )
    {  width =  0.5*fabs(var_valeur(0));
       ini_metric();  
       ech_lp= ( 16 * M_PI * M_PI / 180 ) * cell_volume / (lambda*lambda*lambda);
       }
    else
    {  ech_lp= ( 16 * M_PI * M_PI / 180 ) / (lambda*lambda*lambda);
/*       scale =  0.5*fabs(var_valeur(0)); */
       width =  0.5*fabs(var_valeur(0));
       }
    for (act->lambda=0;act->lambda<l_exper->n_lambda;act->lambda++)
    {    temp = &temp_exper;
         var_init (l_onde);
         lambda = var_valeur (act->lambda * LAMBDA);
         exper_echelle = var_valeur(act->lambda*LAMBDA + 1);
         temp = &temp_phase;
         echelle = phase_echelle * exper_echelle;
         temp = &temp_phase;
         for (p=0,l_points=l_diag->points;p<n_pts;p++,l_points++)
         {    uncoherent = 0;
              sin_t = sin(RAD* *l_points/2);
              cos_t = sqrt(1-sin_t*sin_t);
              cos_2t = 2 * cos_t * cos_t -1;
              s=sin_t/lambda;
              corlp = ech_lp ; 
           /*correction by polarisation factor*/     
             if (polar) corlp *= ( 1.0 + polar * cos_2t*cos_2t) / ( 1 + polar);
           /*correction by resolution factor*/     
             if (resol) 
			    {  d_lambda = 0.0204 * ( 1 - cos_2t );
				    dl_min = d_lambda - width;
					 dl_max = d_lambda + width;
					 if (dl_max + resol < 0 || dl_min - resol > 0) dl_eff = 0;
					 else if (dl_min + resol >= 0 && dl_max - resol <= 0) dl_eff = 1;
					 else if (dl_min + resol < 0 && dl_max - resol > 0) dl_eff = resol/width;
					 else if (dl_min + resol < 0 /*&& dl_max - resol <= 0*/) dl_eff = 0.5*(dl_max-resol)/width;
					 else /*if (dl_min + resol >= 0 && dl_max - resol > 0)*/ dl_eff = 0.5*(resol-dl_min)/width;
					 corlp *= dl_eff;
if  (p % 20 == 0) verbose_printf( "compton dl %.3f   dl_min %.3f dl_max %.3f  resol %.3f    dl_eff %.3f\n",d_lambda, dl_min,
dl_max, resol, dl_eff);
					 }
	/*			  corlp /= 10; */
  /*                if ( d_lambda > 5.0e-3 ) corlp *= ( 5.0e-3/ d_lambda ); */
              if (i_eclair && sin_t<eclair) act->cor *= sin_t/eclair; 
              if (l_phase->nature != PHASE_RADIAL && l_phase->nature != PHASE_RDFPEAK )
              {   for (i=0,l_atom=l_phase->atom;i<l_phase->n_atom;i++,l_atom++)
                  {  var_init (l_atom->x);
                     uncoherent +=  (*valdif)() * var_valeur(3);
                     }
                  for (j=0;j<l_phase->nb_bloc;j++)
                    for (i=0,l_atom=l_phase->bl_relat[j];i<l_phase->bl_atom[j];i++,l_atom++)
                  {  var_init (l_atom->x);
                     uncoherent += (*valdif)() * var_valeur (3);
                     }
                  }
               else
               {  for (i=0,l_atom=l_phase->atom;i<l_phase->n_atom;i++,l_atom++)
                  {   var_init (l_atom->x);
                      uncoherent +=  (*valdif)() * var_valeur(0);
                      }
                   }
          
              uncoherent *= corlp * echelle;
              add_print_unc(p, uncoherent, "cpt");
              } /* points */
         } /* lambda */
    if ( fini && ( unc_mode & 2 ) != 0 ) fprintf(list_fich, "\n"); 
    pop_err_msg();
    }
 /* ---------------------------------------------------------- */
