/* $Id: xnd_t_atom.h,v 1.1 2004/07/30 08:05:02 berar Exp $ */
/* xnd_t_atom.h     header for atom structure   */
/* --------------------------------------------- */
#ifndef  XND_T_ATOM_H_INCLUDED  /* included once only */
#define  XND_T_ATOM_H_INCLUDED
/* ---------------------------------------------- */

typedef struct
{     char    nom[8];
      sint    remark;
      DIFDAT_PTR  xdif;
      DIFDAT_PTR ndif;
      DIFDAT_PTR uxdif;
      DIFDAT_PTR undif;
      DIFDAT_PTR mdif;
      ANODAT_PTR adif;
      int     nature;     /* 0 , 1 bij , 2 ki, 3 bij+ki .....*/
      int     nb;
      int     n_modul;
      int     n_anharm;
      VAR_PTR x;         /* x,y,z,t ,b=b11 (b22 b33 b12 b23 b31) k1 k2 k3 */
      VAR_PTR modul;     /* A_x, A_y, A_z, A_t, P_x, P_y, P_z, P_t, ....  */
      VAR_PTR anharm;    /* D111, .... */
      }   TYPE_ATOM;
/* --------------------------------------------- */
extern TYPE_ATOM  *l_atom;
/* --------------------------------------------- */
/* defined in XND_RATO.C */
TYPE_ATOM * fget_atom PROTO((int nombre, int terme));
/* defined in xnd_atom.c */
char *atom_dif PROTO((char * esp));
/* --------------------------------------------- */
#endif          /*  XND_T_ATOM_H_INCLUDED       */
/* --------------------------------------------- */
