/* $Id: xnd_t_exper.h,v 1.2 2004/07/30 08:05:24 berar Exp $ */
/* xnd_t_exper.h    header for exper structure   */
/* --------------------------------------------- */
#ifndef  XND_T_EXPER_H_INCLUDED  /* included once only */
#define  XND_T_EXPER_H_INCLUDED
/* ---------------------------------------------- */

typedef struct
{     int     cumul;
      int     skip;
      int     numvar;
      float   tmin;
      float   mono;
      }       F_INFO;

typedef struct
{     char    nom[NAME_LG];
      int     nature;
      int     techn;
      int     dfich;
      int     n_lambda;
      int     n_diag;
      int     n_back;
      int     prof_par;
		int     asym_mode; /* allow to modifiy asym mode by experiment */
      int     number;    /* used by orien to adjust function to the experiment */
      int     n_var;
		sint    remark;
      sint    m_back;   /* 1 ou n_manip */
      float   temp_orig;
      float   weight;
      F_INFO  *f_info;
      SCAN_PTR diag;
      VAR_PTR back;	  /* n_back * m_back */
      VAR_PTR onde;       /* n_lambda x 4 */
      VAR_PTR reglage;    /* 4..6   */
      VAR_PTR instru;     /* 4  voire 8  */
      VAR_PTR ascnv;     
      VAR_PTR asym;      /* max_asym * 6 */
      VAR_PTR c_exp;      
      }   TYPE_EXPER;
/* --------------------------------------------- */
extern TYPE_EXPER  *exper;
extern TYPE_EXPER  *l_exper;
/* --------------------------------------------- */
#define ASYM_NO_CONVOL    1
#define ASYM_CONVOL_KNOWN 2
#define ASYM_CONVOL_ISNUM 3
/* --------------------------------------------- */
#endif          /*  XND_T_EXPER_H_INCLUDED       */
/* --------------------------------------------- */
